<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="120px">
      <el-form-item :label="$t('品牌中文标题')" prop="titleZh">
        <el-input v-model="queryParams.titleZh" :placeholder="$t('请输入品牌中文标题')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('品牌英文标题')" prop="titleEn">
        <el-input v-model="queryParams.titleEn" :placeholder="$t('请输入品牌英文标题')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('排序')" prop="aorder">
        <el-input v-model="queryParams.aorder" :placeholder="$t('请输入排序')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
<!--      <el-form-item :label="$t('是否备案')" prop="filing">-->
<!--        <el-select v-model="queryParams.filing" :placeholder="$t('请选择是否备案，字典')" clearable size="small">-->
<!--          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.BRAND_REGISTRY_TYPE)"-->
<!--                       :key="dict.value" :label="dict.label" :value="dict.value"/>-->
<!--        </el-select>-->
<!--      </el-form-item>-->
      <el-form-item :label="$t('是否备案')" prop="filing">
        <el-select v-model="queryParams.filing" :placeholder="$t('请选择是否备案')" clearable size="small">
          <el-option v-for="dict in getDictDatas(DICT_TYPE.BRAND_REG_TYPE)"
                     :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('创建时间')">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:product-brank:create']">{{ $t('新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:product-brank:export']">{{ $t('导出') }}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="主键ID" align="center" prop="id" />
      <el-table-column :label="$t('品牌中文标题')" align="center" prop="titleZh" />
      <el-table-column :label="$t('品牌英文标题')" align="center" prop="titleEn" />
      <el-table-column :label="$t('排序')" align="center" prop="aorder" />
      <el-table-column :label="$t('是否备案')" align="center" prop="filing">
<!--        <template slot-scope="scope">-->
<!--          <dict-tag :type="r in recordStatus" :value="scope.row.filing" />-->
<!--        </template>-->
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.BRAND_REG_TYPE" :value="scope.row.filing" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('创建人')" align="center" prop="creator" width="180">
        <template v-slot="{row}">
          {{(row.creator && allSimplList.length) && allSimplList.find(i => i.id == row.creator).nickname}}
        </template>
      </el-table-column>
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('修改人')" align="center" prop="updater" width="180">
        <template v-slot="{row}">
          {{ (row.updater && allSimplList.length) && allSimplList.find(i => i.id == row.updater).nickname}}
        </template>
      </el-table-column>
      <el-table-column :label="$t('修改时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleEmpower(scope.row)" v-show="scope.row.filing === '1'"
                     v-hasPermi="['ecw:product-brank:update']">{{ $t('添加授权客户') }}</el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:product-brank:update']">{{ $t('修改') }}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:product-brank:delete']">{{ $t('删除') }}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item :label="$t('品牌中文标题')" prop="titleZh">
          <el-input v-model="form.titleZh" :placeholder="$t('请输入品牌中文标题')" />
        </el-form-item>
        <el-form-item :label="$t('品牌英文标题')" prop="titleEn">
          <el-input v-model="form.titleEn" :placeholder="$t('请输入品牌英文标题')" />
        </el-form-item>
        <el-form-item :label="$t('排序')" prop="aorder">
          <el-input v-model="form.aorder" :placeholder="$t('请输入排序')" />
        </el-form-item>
<!--        <el-form-item :label="$t('是否备案')" prop="filing">-->
<!--          <el-radio-group v-model="form.filing">-->
<!--            <el-radio v-for="dict in recordStatus"-->
<!--                      :key="dict.value" :label="dict.value">{{dict.label}}</el-radio>-->
<!--          </el-radio-group>-->
<!--        </el-form-item>-->

        <el-form-item :label="$t('是否备案')" prop="filing">
          <el-select v-model="form.filing" :placeholder="$t('请选择是否备案')">
            <el-option v-for="dict in getDictDatas(DICT_TYPE.BRAND_REG_TYPE)"
                       :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
      </el-form>

      <h3>{{ $t('包含商标列表') }}</h3>

      <brand-form
        :is-show-delete="form.trademarkList.length > 1"
        v-for="(item, index) in form.trademarkList"
        v-model="form.trademarkList[index]"
        :index="index"
        :key="item.id"
        :product-type-list="productTypeList"
        :product-list="productList"
        @delete="form.trademarkList.splice(index, 1)"></brand-form>

      <el-button type="primary" @click="form.trademarkList.push({
        brandName: form.titleZh,
        productBrandId: form.id,
      trademarkCategoryRelList: [{productCategoryId:0, productId:0}]
      })">{{ $t('添加商标') }}</el-button>

      <div slot="footer" style="text-align: center">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>

    <empower :visible.sync="showEmpower" :brandName="empowerTitle" :id="empowerId"></empower>
  </div>
</template>

<script>
import { createProductBrank, updateProductBrank, deleteProductBrank, getProductBrank, getProductBrankPage, exportProductBrankExcel } from "@/api/ecw/productBrank";
import { CommonStatusEnum } from '@/utils/constants';
import {DICT_TYPE, getDictDatas} from "@/utils/dict";
import {getProductTypeList} from "@/api/ecw/productType"
import {getProductList} from "@/api/ecw/product"
import BrandForm from "@/views/ecw/productBrank/BrandForm"
import Empower from "@/views/ecw/productBrank/Empower"
import {listAllSimpl} from "@/api/system/user";

export default {
  name: "ProductBrank",
  components: {
    BrandForm,
    Empower
  },
  data() {
    return {
      getDictDatas,
      DICT_TYPE,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 品牌列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        titleZh: null,
        titleEn: null,
        aorder: null,
        filing: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        titleZh: [{ required: true, message: this.$t('请输入品牌中文标题'), trigger: "blur" }],
        titleEn: [{ required: true, message: this.$t('请输入品牌英文标题'), trigger: "blur" }],
        // aorder: [{ required: true, message: this.$t('请输入排序'), trigger: "blur" }],
        filing: [{ required: true, message: this.$t('请选择是否备案'), trigger: "change" }],
      },
      recordStatus: getDictDatas(DICT_TYPE.BRAND_REG_TYPE),

      productTypeList: [],
      productList: [],

      showEmpower: false,
      empowerId: null,
      empowerTitle: '',
      allSimplList:[],
    };
  },
  created() {
    this.getList();
    getProductTypeList().then(r => {
      this.productTypeList = [{id: 0, titleZh: this.$t('全部')}, ...r.data]
    })
    getProductList().then(r => {
      this.productList = r.data
    });
    listAllSimpl().then(r => {
      this.allSimplList = r.data
    })
  },
  methods: {
    handleEmpower(row){
      this.empowerId = row.id
      this.empowerTitle = row.titleZh
      this.showEmpower = true
    },
    /** 查询列表 */
    getList() {
      this.loading = true;
      if(this.queryParams!=null&&this.queryParams.filing===''){
        this.queryParams.filing=null;
      }
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getProductBrankPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        titleZh: undefined,
        titleEn: undefined,
        aorder: undefined,
        filing: undefined,
        "trademarkList": [
          {
            "brandName": "",
            "trademarkCategoryRelList": [
              {
                "productCategoryId": 0,
                "productId": 0
              }
            ]
          }
        ]
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t("添加品牌");
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getProductBrank(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t("修改品牌");
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        if (this.form.trademarkList?.length > 0){
          // 修改的提交
          if (this.form.id != null) {
            updateProductBrank(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
            return;
          }
          // 添加的提交
          createProductBrank(this.form).then(response => {
            this.$modal.msgSuccess("新增成功");
            this.open = false;
            this.getList();
          });
        } else {
          this.$modal.alert('请至少添加一个商标')
        }

      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除品牌编号为"' + id + '"的数据项?').then(function() {
          return deleteProductBrank(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有品牌数据项?').then(() => {
          this.exportLoading = true;
          return exportProductBrankExcel(params);
        }).then(response => {
          this.$download.excel(response, '品牌.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
